/*************************************************
 * Public Constants
 *************************************************/

#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978

// Pines de los buzzers
const int buzzerMelodiaPin = 28;
const int buzzerAcompanamientoPin = 29;

// Pines de los botones
#define pr 2
#define dbz 4
#define sonic 3

unsigned long previousMillis = 0;
bool isPlaying = false;
int noteIndex = 0;
int* currentMelody = nullptr;
int* currentHarmony = nullptr;
int* currentDurationsMelody = nullptr;
int* currentDurationsHarmony = nullptr;
int currentLength = 0;

// Power Rangers
int melodyPR[] = {NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4, NOTE_E4,
  NOTE_B4, NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4,
  NOTE_E4, NOTE_B4, NOTE_E4, NOTE_B4, NOTE_C5,
  NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4, NOTE_E4,
  NOTE_B4, NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4,
  NOTE_E4, NOTE_B4, NOTE_E4, NOTE_B4, NOTE_C5,
  NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4, NOTE_E4,
  NOTE_B4, NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4,
  NOTE_E4, NOTE_B4, NOTE_E4, NOTE_B4, NOTE_C5,
  NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4, NOTE_E4,
  NOTE_B4, NOTE_E4, NOTE_E4, NOTE_B4, NOTE_E4,
  NOTE_E4, NOTE_B4, NOTE_E4, NOTE_B4, NOTE_C5,//
  NOTE_G5, NOTE_E5, NOTE_G5, NOTE_E5, NOTE_G5,
  NOTE_E5, NOTE_G5, NOTE_E5, NOTE_A5, NOTE_FS5,
  NOTE_A5, NOTE_FS5, NOTE_A5, NOTE_FS5, NOTE_A5,
  NOTE_FS5, NOTE_B5, NOTE_FS5, NOTE_B5, NOTE_FS5,//
  NOTE_B5, NOTE_FS5, NOTE_B5, NOTE_FS5, NOTE_B5,
  NOTE_G5, NOTE_B5, NOTE_G5, NOTE_B5, NOTE_G5,
  NOTE_B5, NOTE_G5, NOTE_C6, NOTE_G5, NOTE_C6,//
  NOTE_G5, NOTE_C6, NOTE_G5, NOTE_C6, NOTE_G5,
  NOTE_C6, NOTE_G5, NOTE_C6, NOTE_G5, NOTE_C6,//
  NOTE_G5, NOTE_C6, NOTE_G5, NOTE_B5, NOTE_B4,
  NOTE_C5, NOTE_DS5, NOTE_D5, NOTE_E5, NOTE_E5,
  NOTE_D5, NOTE_E5, NOTE_G5, NOTE_E5, NOTE_E6,//
  NOTE_E6, NOTE_B6, NOTE_A6, NOTE_G6, NOTE_FS6,
  NOTE_E5, NOTE_E5, NOTE_D5, NOTE_E5, NOTE_G5,
  NOTE_E5, NOTE_E6, NOTE_E6, NOTE_B6, NOTE_A6,//
  NOTE_FS6, NOTE_G6, NOTE_F5, NOTE_F5, NOTE_F5,
  NOTE_F5, NOTE_F5, NOTE_F5, NOTE_F5, NOTE_F5,//
  NOTE_F5, NOTE_F5, NOTE_F5, NOTE_F5, 0};
int harmonyPR[] = {NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3,
  NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3,
  NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3,
  NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3,
  NOTE_C4, NOTE_C4, NOTE_D4, NOTE_D4, NOTE_B3,//
  NOTE_B3, NOTE_E4, NOTE_D4, NOTE_C4, NOTE_C4,
  NOTE_C4, NOTE_C4, NOTE_C4, NOTE_C4, NOTE_C4,
  NOTE_C4, NOTE_B3, NOTE_B3, NOTE_B3, NOTE_B3,//
  NOTE_B3, NOTE_C4, NOTE_DS4, NOTE_D4, NOTE_E4,
  NOTE_E4, NOTE_E4, NOTE_E4, NOTE_E4, NOTE_E4,//
  NOTE_C4, NOTE_C4, NOTE_C4, NOTE_D4, NOTE_D4,
  NOTE_D4, NOTE_E4, NOTE_E4, NOTE_E4, NOTE_E4,//
  NOTE_E4, NOTE_E4, NOTE_C4, NOTE_C4, NOTE_C4,
  NOTE_D4, NOTE_D4, NOTE_D4, NOTE_F4, NOTE_F4,
  NOTE_F4, NOTE_F4, NOTE_F4, NOTE_F4, NOTE_G4,//
  NOTE_G4, NOTE_G4, NOTE_G4, NOTE_G4, 0};
int durationsMelodyPR[] = {125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 250, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 250, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 250, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 1000, 250,
  250, 250, 250, 250, 250,
  125, 250, 250, 1000, 250,//
  250, 250, 250, 250, 250,
  250, 250, 125, 250, 250,
  1000, 250, 250, 250, 250,//
  250, 250, 250, 250, 125,
  250, 250, 1000, 125, 250,//
  250, 250, 250, 250, 500};
int durationsHarmonyPR[] = {500, 500, 500, 500, 500,
  500, 500, 500, 500, 500,
  500, 500, 250, 250, 250,
  250, 250, 250, 250, 250,
  500, 500, 500, 500, 500,//
  500, 500, 500, 250, 250,
  250, 250, 250, 250, 250,
  250, 250, 250, 250, 250,//
  250, 250, 250, 250, 250,
  250, 250, 250, 250, 250,//
  250, 250, 250, 250, 250,
  250, 250, 250, 250, 250,//
  250, 250, 250, 250, 250,
  250, 250, 250, 250, 250,
  250, 250, 250, 250, 250,//
  250, 250, 250, 250, 500};

// Sonic
int melodySonic[] = {0, 0, 0, 0, NOTE_C6,
  NOTE_A5, NOTE_C6, NOTE_B5, NOTE_C6, NOTE_B5,
  NOTE_G5, 0, 0, 0, NOTE_A5,
  NOTE_E6, NOTE_D6, NOTE_C6, NOTE_B5, NOTE_C6,//
  NOTE_B5, NOTE_G5, 0, 0, 0,
  0, NOTE_C6, NOTE_A5, NOTE_C6, NOTE_B5,
  NOTE_C6, NOTE_B5, NOTE_G5, 0, 0,
  0, NOTE_A5, NOTE_A5, NOTE_F5, NOTE_A5,//
  NOTE_G5, NOTE_A5, NOTE_G5, NOTE_C5, 0};
int harmonySonic[] = {NOTE_F3, NOTE_F3, NOTE_F3, NOTE_F3, NOTE_F3,
  NOTE_F3, NOTE_F3, NOTE_F3, NOTE_E3, NOTE_E3,
  NOTE_E3, NOTE_E3, NOTE_E3, NOTE_C3, NOTE_D3,//
  NOTE_E3, NOTE_F3, NOTE_F3, NOTE_F3, NOTE_F3,
  NOTE_F3, NOTE_F3, NOTE_F3, NOTE_F3, NOTE_E3,//
  NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3, NOTE_C3,
  NOTE_D3, NOTE_E3, NOTE_F3, NOTE_F3, NOTE_F3,
  NOTE_F3, NOTE_F3, NOTE_F3, NOTE_F3, NOTE_F3,//
  NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3, NOTE_E3,
  NOTE_C3, NOTE_D3, NOTE_E3, NOTE_D3, NOTE_D3,
  NOTE_D3, NOTE_D3, NOTE_D3, NOTE_D3, NOTE_D3,//
  NOTE_D3, NOTE_C3, NOTE_C3, NOTE_C3, NOTE_C3,
  NOTE_C3, NOTE_C3, NOTE_D3, NOTE_E3, NOTE_F3, 0};
int durationsMelodySonic[] = {125, 125, 125, 125, 125,
  250, 125, 250, 125, 250,
  333, 125, 125, 125, 125, 
  125, 250, 125, 250, 125,//
  250, 333, 125, 125, 125,
  125, 125, 250, 125, 250,
  125, 250, 333, 125, 125,
  125, 125, 125, 250, 125,//
  250, 125, 250, 333, 500};
int durationsHarmonySonic[] = {125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,//
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125, 500};

// Dragon Ball Z
int melodyDBZ[] = {0, NOTE_A5, 0, NOTE_GS5, NOTE_E5,
  0, NOTE_A5, 0, NOTE_GS5, 0,
  NOTE_E5, NOTE_E5, NOTE_D5, NOTE_D5, NOTE_D5,
  0, 0, NOTE_A5, 0, NOTE_GS5,
  NOTE_E5, 0, NOTE_A5, 0, NOTE_GS5,
  0, NOTE_E5, NOTE_E5, NOTE_D5, NOTE_D5,
  NOTE_D5, 0, NOTE_D5, NOTE_D5, NOTE_C5,
  NOTE_C5, NOTE_C5, 0};
int harmonyDBZ[] = {NOTE_E3, NOTE_E3, NOTE_D3, NOTE_D3, NOTE_E3,
  NOTE_E3, NOTE_D3, NOTE_D3, NOTE_C3, NOTE_C3, 0};
int durationsMelodyDBZ[] = {250, 125, 125, 125, 125,
  125, 125, 125, 125, 500,
  250, 250, 125, 250, 500,
  1000, 250, 125, 125, 125,
  125, 125, 125, 125, 125,
  500, 250, 250, 125, 250,
  500, 500, 250, 250, 125,
  250, 500, 500};
int durationsHarmonyDBZ[] = {1000, 1000, 1000, 1000, 1000,
  1000, 1000, 1000, 1000, 1000, 500};


void setup() {
    pinMode(buzzerMelodiaPin, OUTPUT);
    pinMode(buzzerAcompanamientoPin, OUTPUT);
    
    pinMode(pr, INPUT);
    pinMode(dbz, INPUT);
    pinMode(sonic, INPUT);

    Serial.begin(9600);
}

void playNotes() {
  if (isPlaying && noteIndex < currentLength) {
    unsigned long currentMillis = millis();
    if (currentMillis - previousMillis >= currentDurationsMelody[noteIndex]) {
      if (currentMelody[noteIndex] != 0) {
        tone(buzzerMelodiaPin, currentMelody[noteIndex], currentDurationsMelody[noteIndex]);
      } else {
        noTone(buzzerMelodiaPin);
      }
      if (currentHarmony[noteIndex] != 0) {
        tone(buzzerAcompanamientoPin, currentHarmony[noteIndex], currentDurationsHarmony[noteIndex]);
      } else {
        noTone(buzzerAcompanamientoPin);
      }
      previousMillis = currentMillis;
      noteIndex++;
    }
  } else if (noteIndex >= currentLength && isPlaying) {
    noTone(buzzerMelodiaPin);
    noTone(buzzerAcompanamientoPin);
    isPlaying = false;
    noteIndex = 0;
  }
}

void loop() {
  if (!isPlaying) {
    if (digitalRead(pr) == HIGH) {
      Serial.print("Power Rangers Theme!!");
      currentMelody = melodyPR;
      currentHarmony = harmonyPR;
      currentDurationsMelody = durationsMelodyPR;
      currentDurationsHarmony = durationsHarmonyPR;
      currentLength = sizeof(melodyPR) / sizeof(int);
      isPlaying = true;
      noteIndex = 0;
      previousMillis = millis();
    } else if (digitalRead(dbz) == HIGH) {
      Serial.print("Dragon Ball Z Theme!!");
      currentMelody = melodyDBZ;
      currentHarmony = harmonyDBZ;
      currentDurationsMelody = durationsMelodyDBZ;
      currentDurationsHarmony = durationsHarmonyDBZ;
      currentLength = sizeof(melodyDBZ) / sizeof(int);
      isPlaying = true;
      noteIndex = 0;
      previousMillis = millis();
    } else if (digitalRead(sonic) == HIGH) {
      Serial.print("Sonic Theme!!");
      currentMelody = melodySonic;
      currentHarmony = harmonySonic;
      currentDurationsMelody = durationsMelodySonic;
      currentDurationsHarmony = durationsHarmonySonic;
      currentLength = sizeof(melodySonic) / sizeof(int);
      isPlaying = true;
      noteIndex = 0;
      previousMillis = millis();
    }
  }

  playNotes();
}
